getSerialData = function (config) {
    return {
        fnList0: {},
        fnList1: {},
        fnList2: {},
        init: function () {
            this.config = config;
            this.data = { Weight: "0", NFCId: "0", passiveRFID: "0", activeRFID: "0" , tagNum: "0"};

            this.demo = api.require('serialPortPlus');
            // console.log(JSON.stringify(this.demo.getAllDevices()));
            // console.log(JSON.stringify(this.demo.getAllDeicesPath()));


            this.passiveStep = 1;
            this.getPassiveRFID(); //无源
            //this.getActiveRFID(); //有源
            this.getWeight(); //重量
            this.getNFCId(); //NFCID
        },
        getWeight: function () {
            //重量
            var that = this;
            that.demo.open({
                index: 0,
                port: '/dev/ttyS0',
                baudRate: 9600,
            }, function (ret, err) {
                // console.log(JSON.stringify(ret));
                if (!ret.status) {
                    // console.log(JSON.stringify(err));
                    that.demo.close({ index: 0 });
                    that.getWeight();
                    return;
                } else {
                    that.demo.addEventListener({ index: 0, revType: "text" }, function (ret, err) {
                        // console.log(JSON.stringify(ret));
                        var dataarr = ret.data.split(",");
                        if (dataarr[1] == 1) {
                            var Weight = dataarr[0].slice(2, dataarr[0].length);

                            Weight = (Weight + '').replace(/^0+\./g, '0.');
                            Weight.match(/^0+[1-9]+/) ? Weight = Weight.replace(/^0+/g, '') : Weight;
                            Weight = Number(Weight) ? Weight : 0;

                            //console.log("重量 -------> : " + Weight);
                            if (TUI.Utils.floatPrecision(Weight, 1) >= 0) {
                                that.data.Weight = Weight;
                                that.callback(0, that.data);
                                if (TUI.Utils.floatPrecision(Weight, 0) == 0) {
                                    that.data.passiveRFID = "0";
                                    that.data.activeRFID = "0";
                                    that.callback(2, that.data);
                                }
                            }
                        }
                    });
                }
            });
        },
        getNFCId: function () {
            //NFC
            var that = this;
            that.demo.open({
                index: 1,
                port: '/dev/ttyS2',
                baudRate: 9600,
            }, function (ret, err) {
                //console.log(JSON.stringify(ret));
                if (!ret.status) {
                    //console.log(JSON.stringify(err));
                    that.demo.close({ index: 1 });
                    that.getNFCId();
                    return;
                }
                else {
                    that.demo.addEventListener({ index: 1, revType: "text" }, function (ret, err) {
                        //console.log(JSON.stringify(ret));
                        var NFCId = ret.data.replace(/\r\n/g, "")
                        //console.log("NFCId -------> : " + NFCId);
                        that.data.NFCId = NFCId;
                        that.callback(1, that.data);
                    });
                }
            });
        },
        getPassiveRFID: function () {
            //console.log("开始无源")
            // 无源
            var that = this;
            that.demo.open({
                index: 2,
                port: '/dev/ttyS3',
                baudRate: 115200,
                flowCon: 2
            }, function (ret, err) {
                //console.log(JSON.stringify(ret));
                if (!ret.status) {
                    //console.log(JSON.stringify(err));
                    that.demo.close({ index: 2 });
                    that.getPassiveRFID();
                    return;
                }
                else {
                    //console.log("打开串口3成功");
                    that.demo.addEventListener({ index: 2, revType: "hex" }, function (ret, err) {
                        //console.log(ret.dataHex.substring(0, 16));
                        if (ret.dataHex.substring(4, 8) == "4041") // 有源A报文 
                        {
                            var activeRFID = ret.dataHex.substring(26, 36);
                            //console.log("有源RFID -------> : " + activeRFID);
                            that.data.activeRFID = activeRFID;
                            that.ActiveFlag = true;
                            that.callback(2, that.data);
                        }
                        else if (ret.evenType == "onDataReceived" && ret.dataHex == "FF1404000015030400A3000201201604011604010000000010A7AA") { // 发送指令2
                            var ret = that.demo.send({
                                index: 2,
                                sendType: 'hex',
                                data: 'FF052200000300C83814'
                            });
                            // console.log("发送指令2");
                            that.passiveStep++; // passiveStep==3
                        }
                        else if (ret.evenType == "onDataReceived" && ret.dataHex.substring(0, 16) == "FF04220000000003") //发送指令3
                        {
                            if (ret.dataHex.substring(7, 11) == "0400") {
                                // console.log("未检测到无源标签");
                                that.data.passiveRFID = "-0000000000";
                                that.callback(2, that.data);
                            }
                            else if (ret.dataHex.substring(7, 11) == "0000") {
                                var ret = that.demo.send({
                                    index: 2,
                                    sendType: 'hex',
                                    data: 'FF032900BF004B22'
                                });
                                // console.log("发送指令3");
                                that.passiveStep++; // passiveStep==4
                            }
                            else {
                                // console.log("无源标签检测错误");
                                that.data.passiveRFID = "-0000000000";
                                that.callback(2, that.data);
                            }
                        }
                        else if (ret.evenType == "onDataReceived" && that.passiveStep == 4 && ret.dataHex.indexOf("C84F") != -1 &&ret.dataHex.substring(0,2)=="FF") {



                           // console.log(JSON.stringify(ret));
                            var Num16 = ret.dataHex.substring(54, 62);
                            var Num10 = parseInt(Num16, 16);
                            var Num2 = Num10.toString(2) + "";
                            var NumPart = [parseInt(Num2.substring(0, 6), 2), parseInt(Num2.substring(6, 11), 2), parseInt(Num2.substring(11, 22), 2), parseInt(Num2.substring(22, 32), 2)]
                            function padding(num, length) {
                                for (var len = (num + "").length; len < length; len = num.length) {
                                    num = "0" + num;
                                }
                                return num;
                            }
                            var passiveRFID = Num10;
                           // console.log("无源RFID -------> : " + Num16);
                            that.data.passiveRFID = passiveRFID;
                            that.data.activeRFID = passiveRFID;
                            that.callback(2, that.data);
                        }
                    });

                    function startSend() {
                        // console.log("第一次发送");
                        var ret = that.demo.send({
                            index: 2,
                            sendType: 'hex',
                            data: 'FF00041D0B'
                        });
                        // console.log(JSON.stringify(ret));
                        that.passiveStep = 2; // passiveStep==2
                    }

                    function secondSend() {
 //                       console.log("第二次发送");
                        var ret = that.demo.send({
                            index: 2,
                            sendType: 'hex',
                            data: 'FF052200000300C83814'
                        });
                        // console.log(JSON.stringify(ret));
                        that.passiveStep = 3; // passiveStep==3
                    }

                    setTimeout(startSend, 100);
                    setInterval(secondSend, 500);
                }
            });
        },
        getActiveRFID: function () {
            console.log("开始有源")
            // 有源
            var that = this;
            that.demo.open({
                index: 3,
                port: '/dev/ttyS3',
                baudRate: 115200,
                flowCon: 2
            }, function (ret, err) {
                // // console.log(JSON.stringify(ret));
                if (!ret.status) {
                    // console.log(JSON.stringify(err));
                    that.demo.close({ index: 3 });
                    that.getActiveRFID();
                    return;
                }
                else {
                    that.ActiveFlag = false;
                    that.demo.addEventListener({ index: 3, revType: "hex" }, function (ret, err) {
                        //console.log(JSON.stringify(ret));
                        if (ret.dataHex.substring(4, 8) == "4041") // A报文 
                        {
                            var activeRFID = ret.dataHex.substring(26, 36);
                             //console.log("有源RFID -------> : " + activeRFID);
                            that.data.activeRFID = activeRFID;
                            that.ActiveFlag = true;
                            that.callback(2, that.data);
                        }
                        else if (ret.dataHex.substring(0, 12) == "FF1C29000000") // 无源
                        {
                            var Num16 = ret.dataHex.substring(54, 62);
                            var Num10 = parseInt(Num16, 16);
                            var Num2 = Num10.toString(2) + "";
                            var NumPart = [parseInt(Num2.substring(0, 6), 2), parseInt(Num2.substring(6, 11), 2), parseInt(Num2.substring(11, 22), 2), parseInt(Num2.substring(22, 32), 2)]
                            function padding(num, length) {
                                for (var len = (num + "").length; len < length; len = num.length) {
                                    num = "0" + num;
                                }
                                return num;
                            }
                            var passiveRFID = Num10;
                            console.log("有源RFID -------> : " + passiveRFID);
                            that.data.passiveRFID = passiveRFID;
                            that.data.activeRFID = passiveRFID;
                            that.callback(2, that.data);
                        }
                    });
                }
            });
        },
        addEventListener: function (index, fn) {
            if (index == 0) {
                // console.log("add");
                this.fnList0 = fn;

            } else if (index == 1) {
                this.fnList1 = fn;
            } else if (index == 2) {
                this.fnList2 = fn;
            }
        },
        removeEventListener: function (index) {
            if (index == 0) {
                this.fnList0 = {};
            } else if (index == 1) {
                this.fnList1 = {};
            } else if (index == 2) {
                this.fnList2 = {};
            }
        },
        callback: function (index, data) {
            if (index == 0) {
                if (typeof (eval(this.fnList0)) == "function") {
                    eval(this.fnList0).call(this, data);
                }
            } else if (index == 1) {
                if (typeof (eval(this.fnList1)) == "function") {
                    eval(this.fnList1).call(this, data);
                }
            } else if (index == 2) {
                if (typeof (eval(this.fnList2)) == "function") {
                    eval(this.fnList2).call(this, data);
                }
            }
        }
    }
};